## ros-galactic-foros-examples 0.4.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8)
project(foros_examples)

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake REQUIRED)
find_package(rclcpp REQUIRED)
find_package(foros REQUIRED)
find_package(std_msgs REQUIRED)
find_package(std_srvs REQUIRED)

add_executable(cluster_election src/cluster_election.cpp)
ament_target_dependencies(cluster_election
  rclcpp
  foros
)

install(
  TARGETS cluster_election EXPORT cluster_election
  DESTINATION lib/${PROJECT_NAME}
)

add_executable(cluster_service src/cluster_service.cpp)
ament_target_dependencies(cluster_service
  rclcpp
  foros
  std_srvs
)

install(
  TARGETS cluster_service EXPORT cluster_service
  DESTINATION lib/${PROJECT_NAME}
)

add_executable(cluster_client src/cluster_client.cpp)
ament_target_dependencies(cluster_client
  rclcpp
  foros
  std_srvs
)

install(
  TARGETS cluster_client EXPORT cluster_client
  DESTINATION lib/${PROJECT_NAME}
)

add_executable(cluster_publisher src/cluster_publisher.cpp)
ament_target_dependencies(cluster_publisher
  rclcpp
  foros
  std_msgs
)

install(
  TARGETS cluster_publisher EXPORT cluster_publisher
  DESTINATION lib/${PROJECT_NAME}
)

add_executable(cluster_subscriber src/cluster_subscriber.cpp)
ament_target_dependencies(cluster_subscriber
  rclcpp
  foros
  std_msgs
)

install(
  TARGETS cluster_subscriber EXPORT cluster_subscriber
  DESTINATION lib/${PROJECT_NAME}
)

add_executable(cluster_log_replication_with_commit src/cluster_log_replication_with_commit.cpp)
ament_target_dependencies(cluster_log_replication_with_commit
  rclcpp
  foros
)

install(
  TARGETS cluster_log_replication_with_commit EXPORT cluster_log_replication_with_commit
  DESTINATION lib/${PROJECT_NAME}
)
add_executable(cluster_log_replication_without_commit src/cluster_log_replication_without_commit.cpp)
ament_target_dependencies(cluster_log_replication_without_commit
  rclcpp
  foros
)

install(
  TARGETS cluster_log_replication_without_commit EXPORT cluster_log_replication_without_commit
  DESTINATION lib/${PROJECT_NAME}
)

if(BUILD_TESTING)
  find_package(ament_cmake_cpplint REQUIRED)
  ament_cpplint(FILTERS "-build/header_guard,-build/include_order")

  find_package(ament_cmake_cppcheck REQUIRED)
  ament_cppcheck()

  find_package(ament_cmake_lint_cmake REQUIRED)
  ament_lint_cmake()

  find_package(ament_cmake_xmllint REQUIRED)
  ament_xmllint()

endif()

ament_package()

=== debian/changelog ===
ros-galactic-foros-examples (0.4.1-2focal) focal; urgency=high



 -- Wonguk Jeong <wonguk.jeong@42dot.ai>  Sat, 12 Nov 2022 15:00:00 -0000

ros-galactic-foros-examples (0.4.0-2focal) focal; urgency=high

  * version 0.4.0
  * foros_examples: fix missing exception handler
  * Contributors: Wonguk Jeong

 -- Wonguk Jeong <wonguk.jeong@42dot.ai>  Wed, 26 Oct 2022 15:00:00 -0000

ros-galactic-foros-examples (0.3.1-2focal) focal; urgency=high

  * Version 0.3.1
    - inspector UI enhanced
    - unit test updated
  * Contributors: Wonguk Jeong

 -- Wonguk Jeong <wonguk.jeong@42dot.ai>  Tue, 26 Apr 2022 15:00:00 -0000

ros-galactic-foros-examples (0.3.0-2focal) focal; urgency=high

  * Version 0.3.0
    - inspector introduced
    - locking added for multithreading
  * foros_examples: support ros2 run
    change install directory from 'bin' to 'lib/foros_examples'
  * foros_examples: rename node
  * Contributors: Wonguk Jeong

 -- Wonguk Jeong <wonguk.jeong@42dot.ai>  Sun, 24 Apr 2022 15:00:00 -0000

ros-galactic-foros-examples (0.1.0-2focal) focal; urgency=high

  * foros_examples: add missing dependency
    std_msgs dependency added in package.xml, CMakeLists.txt
  * foros_examples: log replication test updated
    - "clsuter_log_replication_with_commit" commit every 1 sec
    - "cluster_log_replication_withou_commit" check replication by callback
  * foros_example/cluster_service: support test with given cluster size
  * foros_example/cluster_publisher: support test with given cluster size
  * foros_examples/cluster_election: support test with given cluster size
  * foros: use rclcpp logger not std::cerr, std::cout
  * foros: data commit API implemented
  * foros: refine cluster node data itnerface
    Do not use internal terminology in APIs
    - index -> id
    - term -> sub_id
  * foros: update commit index, next index as needed
    1) update last commit index,
    - on local commit
    - on rollback commit
    2) update next indeice of other nodes, when the node becomes leader
  * foros: data replication logic added (phase 1)
    - implemented replication using broadcast
    - example added
    TODO:
    - bug fix
    - implement replication using data commit API
  * foros: add lifecycle callback register APIs
    The virtual function is not guarenteed to be invoked in the constructor.
    Therefore, uses register APIs not overriding
    As-Is: overriding using interface
    To-Be: register using API explicitly
  * foros: add data replicatoin logic in RPC response
  * fsros: add prev commt info in Data class
    To achieve raft data duplication, need to pass previous commit index
    and previous commit term.
  * foros: data commit interface added
    for data replication,
    1) add data interface API
    2) data commit API added in raft context
  * foros: align coding style (CommitData, CommitResponse)
  * foros: change commit data API to asnyc API
    This API need to make a consensus in the cluster.
    Therefore, change to async API.
    - use promise-future
    - for now, return result immediately
    until the business logic is implemented.
  * rename failsafe::fsros to failover::foros
  * Contributors: Wonguk Jeong

 -- Wonguk Jeong <wonguk.jeong@42dot.ai>  Tue, 21 Dec 2021 15:00:00 -0000

=== debian/control ===
Source: ros-galactic-foros-examples
Section: misc
Priority: optional
Maintainer: Wonguk Jeong <wonguk.jeong@42dot.ai>
Build-Depends: debhelper (>= 9.0.0), ros-galactic-ament-cmake, ros-galactic-ament-lint-common <!nocheck>, ros-galactic-foros, ros-galactic-rclcpp, ros-galactic-std-msgs, ros-galactic-std-srvs, ros-galactic-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-galactic-foros-examples
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-galactic-foros, ros-galactic-rclcpp, ros-galactic-std-msgs, ros-galactic-std-srvs, ros-galactic-ros-workspace
Description: Fail over ROS examples

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/galactic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/galactic" \
		-DAMENT_PREFIX_PATH="/opt/ros/galactic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/galactic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-galactic-foros-examples//opt/ros/galactic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_install
